diff -r f6ef988fda71 trytond/ir/action.py
--- a/trytond/ir/action.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/action.py	Sun Sep 23 17:30:03 2012 +0200
@@ -713,122 +683,105 @@
                         return False
         return True
 
-    def get_views(self, ids, name):
-        res = {}
-        for act in self.browse(ids):
-            res[act.id] = [(view.view.id, view.view.type)
-                    for view in act.act_window_views]
-        return res
+    def get_views(self, name):
+        return [(view.view.id, view.view.type)
+            for view in self.act_window_views]
 
-    def get_pyson(self, ids, name):
-        res = {}
+    @classmethod
+    def get_pyson(cls, windows, name):
+        pysons = {}
         encoder = PYSONEncoder()
         field = name[6:]
         defaults = {
             'domain': '[]',
             'context': '{}',
             'search_value': '{}',
-        }
-        for act in self.browse(ids):
-            res[act.id] = encoder.encode(safe_eval(act[field] or
-                defaults.get(field, 'None'), CONTEXT))
-        return res
+            }
+        for window in windows:
+            pysons[window.id] = encoder.encode(safe_eval(getattr(window, field)
+                    or defaults.get(field, 'None'), CONTEXT))
+        return pysons
 
-    def create(self, vals):
+    @classmethod
+    def create(cls, vals):
         later = {}
         vals = vals.copy()
         for field in vals:
-            if field in self._columns \
-                    and hasattr(self._columns[field], 'set'):
+            if (field in cls._fields
+                    and hasattr(cls._fields[field], 'set')):
                 later[field] = vals[field]
         for field in later:
             del vals[field]
         cursor = Transaction().cursor
-        if cursor.nextid(self._table):
-            cursor.setnextid(self._table, cursor.currid('ir_action'))
-        new_id = super(ActionActWindow, self).create(vals)
-        act_window = self.browse(new_id)
+        if cursor.nextid(cls._table):
+            cursor.setnextid(cls._table, cursor.currid('ir_action'))
+        act_window = super(ActionActWindow, cls).create(vals)
         new_id = act_window.action.id
-        cursor.execute('UPDATE "' + self._table + '" SET id = %s ' \
+        cursor.execute('UPDATE "' + cls._table + '" SET id = %s ' \
                 'WHERE id = %s', (act_window.action.id, act_window.id))
-        cursor.update_auto_increment(self._table, act_window.action.id)
-        ModelStorage.delete(self, act_window.id)
-        self.write(new_id, later)
-        return new_id
+        cursor.update_auto_increment(cls._table, act_window.action.id)
+        act_window = cls(new_id)
+        cls.write([act_window], later)
+        return act_window
 
-    def delete(self, ids):
-        pool = Pool()
-        action_obj = pool.get('ir.action')
+    @classmethod
+    def delete(cls, act_windows):
+        Action = Pool().get('ir.action')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        action_ids = [x.action.id for x in self.browse(ids)]
+        actions = [x.action.id for x in act_windows]
+        super(ActionActWindow, cls).delete(act_windows)
+        Action.delete(actions)
 
-        res = super(ActionActWindow, self).delete(ids)
-        action_obj.delete(action_ids)
-        return res
-
-    def get(self, xml_id):
+    @classmethod
+    def get(cls, xml_id):
         'Get values from XML id'
         pool = Pool()
-        model_data_obj = pool.get('ir.model.data')
-        action_obj = pool.get('ir.action')
-        action_id = model_data_obj.get_id(*xml_id.split('.'))
-        return action_obj.get_action_values(self._name, action_id)
+        ModelData = pool.get('ir.model.data')
+        Action = pool.get('ir.action')
+        action_id = ModelData.get_id(*xml_id.split('.'))
+        return Action.get_action_values(cls.__name__, [action_id])[0]
 
-    def copy(self, ids, default=None):
-        action_obj = Pool().get('ir.action')
-
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
+    @classmethod
+    def copy(cls, actions, default=None):
+        Action = Pool().get('ir.action')
         if default is None:
             default = {}
         default = default.copy()
-        new_ids = []
-        for act_window in self.browse(ids):
-            default['action'] = action_obj.copy(act_window.action.id)
-            new_id = super(ActionActWindow, self).copy(act_window.id,
-                default=default)
-            new_ids.append(new_id)
-
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-ActionActWindow()
+        new_actions = []
+        for act_window in actions:
+            default['action'] = Action.copy([act_window.action])[0].id
+            new_actions.extend(super(ActionActWindow, cls).copy([act_window],
+                    default=default))
+        return new_actions
 
 
 class ActionActWindowView(ModelSQL, ModelView):
     "Action act window view"
-    _name = 'ir.action.act_window.view'
+    __name__ = 'ir.action.act_window.view'
     _rec_name = 'view'
-    _description = __doc__
     sequence = fields.Integer('Sequence', required=True)
     view = fields.Many2One('ir.ui.view', 'View', required=True,
             ondelete='CASCADE')
     act_window = fields.Many2One('ir.action.act_window', 'Action',
             ondelete='CASCADE')
 
-    def __init__(self):
-        super(ActionActWindowView, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ActionActWindowView, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
-        super(ActionActWindowView, self).init(module_name)
-        table = TableHandler(Transaction().cursor, self, module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(ActionActWindowView, cls).__register__(module_name)
+        table = TableHandler(Transaction().cursor, cls, module_name)
 
         # Migration from 1.0 remove multi
         table.drop_column('multi')
 
-ActionActWindowView()
-
 
 class ActionWizard(ModelSQL, ModelView):
     "Action wizard"
-    _name = 'ir.action.wizard'
-    _description = __doc__
+    __name__ = 'ir.action.wizard'
     _inherits = {'ir.action': 'action'}
     wiz_name = fields.Char('Wizard name', required=True)
     action = fields.Many2One('ir.action', 'Action', required=True,
@@ -837,134 +790,115 @@
     email = fields.Char('Email')
     window = fields.Boolean('Window', help='Run wizard in a new window')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'ir.action.wizard'
 
-    def create(self, vals):
+    @classmethod
+    def create(cls, vals):
         later = {}
         vals = vals.copy()
         for field in vals:
-            if field in self._columns \
-                    and hasattr(self._columns[field], 'set'):
+            if (field in cls._fields
+                    and hasattr(cls._fields[field], 'set')):
                 later[field] = vals[field]
         for field in later:
             del vals[field]
         cursor = Transaction().cursor
-        if cursor.nextid(self._table):
-            cursor.setnextid(self._table, cursor.currid('ir_action'))
-        new_id = super(ActionWizard, self).create(vals)
-        wizard = self.browse(new_id)
+        if cursor.nextid(cls._table):
+            cursor.setnextid(cls._table, cursor.currid('ir_action'))
+        wizard = super(ActionWizard, cls).create(vals)
         new_id = wizard.action.id
-        cursor.execute('UPDATE "' + self._table + '" SET id = %s ' \
+        cursor.execute('UPDATE "' + cls._table + '" SET id = %s ' \
                 'WHERE id = %s', (wizard.action.id, wizard.id))
-        cursor.update_auto_increment(self._table, wizard.action.id)
-        ModelStorage.delete(self, wizard.id)
-        self.write(new_id, later)
-        return new_id
+        cursor.update_auto_increment(cls._table, wizard.action.id)
+        wizard = cls(new_id)
+        cls.write([wizard], later)
+        return wizard
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, wizards):
         pool = Pool()
-        action_obj = pool.get('ir.action')
+        Action = pool.get('ir.action')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        action_ids = [x.action.id for x in self.browse(ids)]
+        actions = [x.action.id for x in wizards]
 
-        res = super(ActionWizard, self).delete(ids)
-        action_obj.delete(action_ids)
-        return res
+        super(ActionWizard, cls).delete(wizards)
+        Action.delete(actions)
 
-    def copy(self, ids, default=None):
-        action_obj = Pool().get('ir.action')
+    @classmethod
+    def copy(cls, wizards, default=None):
+        Action = Pool().get('ir.action')
 
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
         if default is None:
             default = {}
         default = default.copy()
-        new_ids = []
-        for wizard in self.browse(ids):
-            default['action'] = action_obj.copy(wizard.action.id)
-            new_id = super(ActionWizard, self).copy(wizard.id,
-                default=default)
-            new_ids.append(new_id)
-
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-ActionWizard()
+        new_wizards = []
+        for wizard in wizards:
+            default['action'] = Action.copy([wizard.action])[0].id
+            new_wizards.extend(super(ActionWizard, cls).copy([wizard],
+                    default=default))
+        return new_wizards
 
 
 class ActionURL(ModelSQL, ModelView):
     "Action URL"
-    _name = 'ir.action.url'
-    _description = __doc__
+    __name__ = 'ir.action.url'
     _inherits = {'ir.action': 'action'}
     url = fields.Char('Action Url', required=True)
     action = fields.Many2One('ir.action', 'Action', required=True,
             ondelete='CASCADE')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'ir.action.url'
 
-    def default_target(self):
+    @staticmethod
+    def default_target():
         return 'new'
 
-    def create(self, vals):
+    @classmethod
+    def create(cls, vals):
         later = {}
         vals = vals.copy()
         for field in vals:
-            if field in self._columns \
-                    and hasattr(self._columns[field], 'set'):
+            if (field in cls._fields
+                    and hasattr(cls._fields[field], 'set')):
                 later[field] = vals[field]
         for field in later:
             del vals[field]
         cursor = Transaction().cursor
-        if cursor.nextid(self._table):
-            cursor.setnextid(self._table, cursor.currid('ir_action'))
-        new_id = super(ActionURL, self).create(vals)
-        url = self.browse(new_id)
+        if cursor.nextid(cls._table):
+            cursor.setnextid(cls._table, cursor.currid('ir_action'))
+        url = super(ActionURL, cls).create(vals)
         new_id = url.action.id
-        cursor.execute('UPDATE "' + self._table + '" SET id = %s ' \
+        cursor.execute('UPDATE "' + cls._table + '" SET id = %s ' \
                 'WHERE id = %s', (url.action.id, url.id))
-        cursor.update_auto_increment(self._table, url.action.id)
-        ModelStorage.delete(self, url.id)
-        self.write(new_id, later)
-        return new_id
+        cursor.update_auto_increment(cls._table, url.action.id)
+        url = cls(new_id)
+        cls.write([url], later)
+        return url
 
-    def delete(self, ids):
+    @classmethod
+    def delete(cls, urls):
         pool = Pool()
-        action_obj = pool.get('ir.action')
+        Action = pool.get('ir.action')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        action_ids = [x.action.id for x in self.browse(ids)]
+        actions = [x.action for x in urls]
 
-        res = super(ActionURL, self).delete(ids)
-        action_obj.delete(action_ids)
-        return res
+        super(ActionURL, cls).delete(urls)
+        Action.delete(actions)
 
-    def copy(self, ids, default=None):
-        action_obj = Pool().get('ir.action')
+    @classmethod
+    def copy(cls, urls, default=None):
+        Action = Pool().get('ir.action')
 
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
         if default is None:
             default = {}
         default = default.copy()
-        new_ids = []
-        for url in self.browse(ids):
-            default['action'] = action_obj.copy(url.action.id)
-            new_id = super(ActionURL, self).copy(url.id, default=default)
-            new_ids.append(new_id)
-
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-ActionURL()
+        new_urls = []
+        for url in urls:
+            default['action'] = Action.copy([url.action])[0].id
+            new_urls.extend(super(ActionURL, cls).copy([url],
+                    default=default))
+        return new_urls
diff -r f6ef988fda71 trytond/ir/attachment.py
--- a/trytond/ir/attachment.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/attachment.py	Sun Sep 23 17:30:03 2012 +0200
@@ -13,6 +13,10 @@
 from ..pyson import Eval
 from ..pool import Pool
 
+__all__ = [
+    'Attachment',
+    ]
+
 
 def firstline(description):
     try:
@@ -23,8 +27,7 @@
 
 class Attachment(ModelSQL, ModelView):
     "Attachment"
-    _name = 'ir.attachment'
-    _description = __doc__
+    __name__ = 'ir.attachment'
     name = fields.Char('Name', required=True)
     type = fields.Selection([
         ('data', 'Data'),
@@ -35,7 +38,7 @@
                 }, depends=['type']), 'get_data', setter='set_data')
     description = fields.Text('Description')
     summary = fields.Function(fields.Char('Summary',
-        on_change_with=['description']), 'get_summary')
+        on_change_with=['description']), 'on_change_with_summary')
     resource = fields.Reference('Resource', selection='models_get',
         select=True)
     link = fields.Char('Link', states={
@@ -47,23 +50,25 @@
                 'invisible': Eval('type') != 'data',
                 }, depends=['type']), 'get_data')
     last_modification = fields.Function(fields.DateTime('Last Modification'),
-            'get_last_modification')
+        'get_last_modification')
     last_user = fields.Function(fields.Char('Last User'),
         'get_last_user')
 
-    def __init__(self):
-        super(Attachment, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Attachment, cls).__setup__()
+        cls._sql_constraints += [
             ('resource_name', 'UNIQUE(resource, name)',
                 'The  names of attachments must be unique by resource!'),
         ]
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
 
-        super(Attachment, self).init(module_name)
+        super(Attachment, cls).__register__(module_name)
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 1.4 res_model and res_id merged into resource
         # Reference
@@ -71,58 +76,61 @@
                 table.column_exist('res_id'):
             table.drop_constraint('res_model_res_id_name')
             cursor.execute('UPDATE "%s" '
-            'SET "resource" = "res_model"||\',\'||"res_id"' % self._table)
+            'SET "resource" = "res_model"||\',\'||"res_id"' % cls._table)
             table.drop_column('res_model')
             table.drop_column('res_id')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'data'
 
-    def default_resource(self):
+    @staticmethod
+    def default_resource():
         return Transaction().context.get('resource')
 
-    def default_collision(self):
+    @staticmethod
+    def default_collision():
         return 0
 
-    def models_get(self):
+    @staticmethod
+    def models_get():
         pool = Pool()
-        model_obj = pool.get('ir.model')
-        model_ids = model_obj.search([])
+        Model = pool.get('ir.model')
+        models = Model.search([])
         res = []
-        for model in model_obj.browse(model_ids):
+        for model in models:
             res.append([model.model, model.name])
         return res
 
-    def get_data(self, ids, name):
-        res = {}
+    def get_data(self, name):
         db_name = Transaction().cursor.dbname
-        format_ = Transaction().context.pop('%s.%s' % (self._name, name), '')
-        for attachment in self.browse(ids):
-            value = None
+        format_ = Transaction().context.pop('%s.%s'
+            % (self.__name__, name), '')
+        value = None
+        if name == 'data_size' or format_ == 'size':
+            value = 0
+        if self.digest:
+            filename = self.digest
+            if self.collision:
+                filename = filename + '-' + str(self.collision)
+            filename = os.path.join(CONFIG['data_path'], db_name,
+                    filename[0:2], filename[2:4], filename)
             if name == 'data_size' or format_ == 'size':
-                value = 0
-            if attachment.digest:
-                filename = attachment.digest
-                if attachment.collision:
-                    filename = filename + '-' + str(attachment.collision)
-                filename = os.path.join(CONFIG['data_path'], db_name,
-                        filename[0:2], filename[2:4], filename)
-                if name == 'data_size' or format_ == 'size':
-                    try:
-                        statinfo = os.stat(filename)
-                        value = statinfo.st_size
-                    except OSError:
-                        pass
-                else:
-                    try:
-                        with open(filename, 'rb') as file_p:
-                            value = buffer(file_p.read())
-                    except IOError:
-                        pass
-            res[attachment.id] = value
-        return res
+                try:
+                    statinfo = os.stat(filename)
+                    value = statinfo.st_size
+                except OSError:
+                    pass
+            else:
+                try:
+                    with open(filename, 'rb') as file_p:
+                        value = buffer(file_p.read())
+                except IOError:
+                    pass
+        return value
 
-    def set_data(self, ids, name, value):
+    @classmethod
+    def set_data(cls, attachments, name, value):
         if value is None:
             return
         cursor = Transaction().cursor
@@ -168,77 +176,73 @@
         else:
             with open(filename, 'wb') as file_p:
                 file_p.write(value)
-        self.write(ids, {
+        cls.write(attachments, {
             'digest': digest,
             'collision': collision,
             })
 
-    def get_summary(self, ids, name):
-        return dict((x.id, firstline(x.description or ''))
-            for x in self.browse(ids))
+    def on_change_with_summary(self, name=None):
+        return firstline(self.description or '')
 
-    def on_change_with_summary(self, values):
-        return firstline(values.get('description') or '')
+    def get_last_modification(self, name):
+        return (self.write_date if self.write_date else self.create_date
+            ).replace(microsecond=0)
 
-    def get_last_modification(self, ids, name):
-        return dict((x.id, (x.write_date if x.write_date else x.create_date
-            ).replace(microsecond=0))
-            for x in self.browse(ids))
+    @classmethod
+    def get_last_user(cls, attachments, name):
+        with Transaction().set_user(0):
+            return dict(
+                (x.id, x.write_uid.rec_name
+                    if x.write_uid else x.create_uid.rec_name)
+                for x in cls.browse(attachments))
 
-    def get_last_user(self, ids, name):
-        with Transaction().set_user(0):
-            return dict((x.id, x.write_uid.rec_name if x.write_uid
-                else x.create_uid.rec_name) for x in self.browse(ids))
-
-    def check_access(self, ids, mode='read'):
+    @classmethod
+    def check_access(cls, ids, mode='read'):
         pool = Pool()
-        model_access_obj = pool.get('ir.model.access')
+        ModelAccess = pool.get('ir.model.access')
         if Transaction().user == 0:
             return
-        if not ids:
-            return
-        if isinstance(ids, (int, long)):
-            ids = [ids]
         model_names = set()
         with Transaction().set_user(0):
-            for attachment in self.browse(ids):
+            for attachment in cls.browse(ids):
                 if attachment.resource:
                     model_names.add(attachment.resource.split(',')[0])
         for model_name in model_names:
-            model_access_obj.check(model_name, mode=mode)
+            ModelAccess.check(model_name, mode=mode)
 
-    def read(self, ids, fields_names=None):
-        self.check_access(ids, mode='read')
-        return super(Attachment, self).read(ids, fields_names=fields_names)
+    @classmethod
+    def read(cls, ids, fields_names=None):
+        cls.check_access(ids, mode='read')
+        return super(Attachment, cls).read(ids, fields_names=fields_names)
 
-    def delete(self, ids):
-        self.check_access(ids, mode='delete')
-        return super(Attachment, self).delete(ids)
+    @classmethod
+    def delete(cls, attachments):
+        cls.check_access([a.id for a in attachments], mode='delete')
+        super(Attachment, cls).delete(attachments)
 
-    def write(self, ids, vals):
-        self.check_access(ids, mode='write')
-        res = super(Attachment, self).write(ids, vals)
-        self.check_access(ids, mode='write')
-        return res
+    @classmethod
+    def write(cls, attachments, vals):
+        cls.check_access([a.id for a in attachments], mode='write')
+        super(Attachment, cls).write(attachments, vals)
+        cls.check_access(attachments, mode='write')
 
-    def create(self, vals):
-        res = super(Attachment, self).create(vals)
-        self.check_access(res, mode='create')
-        return res
+    @classmethod
+    def create(cls, vals):
+        attachment = super(Attachment, cls).create(vals)
+        cls.check_access([attachment.id], mode='create')
+        return attachment
 
-    def view_header_get(self, value, view_type='form'):
+    @classmethod
+    def view_header_get(cls, value, view_type='form'):
         pool = Pool()
-        ir_model_obj = pool.get('ir.model')
-        value = super(Attachment, self).view_header_get(value,
+        Model = pool.get('ir.model')
+        value = super(Attachment, cls).view_header_get(value,
                 view_type=view_type)
         resource = Transaction().context.get('resource')
         if resource:
             model_name, record_id = resource.split(',', 1)
-            ir_model_id, = ir_model_obj.search([('model', '=', model_name)])
-            ir_model = ir_model_obj.browse(ir_model_id)
-            model_obj = pool.get(model_name)
-            record = model_obj.browse(int(record_id))
+            ir_model, = Model.search([('model', '=', model_name)])
+            Resource = pool.get(model_name)
+            record = Resource(int(record_id))
             value = '%s - %s - %s' % (ir_model.name, record.rec_name, value)
         return value
-
-Attachment()
diff -r f6ef988fda71 trytond/ir/cache.py
--- a/trytond/ir/cache.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/cache.py	Sun Sep 23 17:30:03 2012 +0200
@@ -2,12 +2,13 @@
 #this repository contains the full copyright notices and license terms.
 from ..model import ModelSQL, fields
 
+__all__ = [
+    'Cache',
+    ]
+
 
 class Cache(ModelSQL):
     "Cache"
-    _name = 'ir.cache'
-    _description = __doc__
+    __name__ = 'ir.cache'
     name = fields.Char('Name', required=True)
     timestamp = fields.DateTime('Timestamp')
-
-Cache()
diff -r f6ef988fda71 trytond/ir/cron.py
--- a/trytond/ir/cron.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/ir/cron.py	Sun Sep 23 17:30:03 2012 +0200
@@ -13,6 +13,10 @@
 from ..pool import Pool
 from ..backend import TableHandler
 
+__all__ = [
+    'Cron',
+    ]
+
 _INTERVALTYPES = {
     'days': lambda interval: relativedelta(days=interval),
     'hours': lambda interval: relativedelta(hours=interval),
@@ -24,8 +28,7 @@
 
 class Cron(ModelSQL, ModelView):
     "Cron"
-    _name = "ir.cron"
-    _description = __doc__
+    __name__ = "ir.cron"
     name = fields.Char('Name', required=True, translate=True)
     user = fields.Many2One('res.user', 'Execution User', required=True,
         domain=[('active', '=', False)],
@@ -53,65 +56,76 @@
     function = fields.Char('Function')
     args = fields.Text('Arguments')
 
-    def __init__(self):
-        super(Cron, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Cron, cls).__setup__()
+        cls._error_messages.update({
             'request_title': 'Scheduled action failed',
             'request_body': "The following action failed to execute "
                             "properly: \"%s\"\n Traceback: \n\n%s\n"
             })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
 
         # Migration from 2.0: rename numbercall, doall and nextcall
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.column_rename('numbercall', 'number_calls')
         table.column_rename('doall', 'repeat_missed')
         table.column_rename('nextcall', 'next_call')
         table.drop_column('running')
 
-        super(Cron, self).init(module_name)
+        super(Cron, cls).__register__(module_name)
 
         # Migration from 2.0: work_days removed
         cursor.execute('UPDATE "%s" '
             'SET interval_type = %%s '
-            'WHERE interval_type = %%s' % self._table,
+            'WHERE interval_type = %%s' % cls._table,
             ('days', 'work_days'))
 
-    def default_next_call(self):
+    @staticmethod
+    def default_next_call():
         return datetime.datetime.now()
 
-    def default_interval_number(self):
+    @staticmethod
+    def default_interval_number():
         return 1
 
-    def default_interval_type(self):
+    @staticmethod
+    def default_interval_type():
         return 'months'
 
-    def default_number_calls(self):
+    @staticmethod
+    def default_number_calls():
         return -1
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_repeat_missed(self):
+    @staticmethod
+    def default_repeat_missed():
         return True
 
-    def check_xml_record(self, ids, values):
+    @staticmethod
+    def check_xml_record(crons, values):
         return True
 
-    def get_delta(self, cron):
+    @staticmethod
+    def get_delta(cron):
         '''
         Return the relativedelta for the next call
         '''
         return _INTERVALTYPES[cron.interval_type](cron.interval_number)
 
-    def _get_request_values(self, cron):
+    @classmethod
+    def _get_request_values(cls, cron):
         tb_s = ''.join(traceback.format_exception(*sys.exc_info()))
         tb_s = tb_s.decode('utf-8', 'ignore')
-        name = self.raise_user_error('request_title',
+        name = cls.raise_user_error('request_title',
             raise_exception=False)
-        body = self.raise_user_error('request_body', (cron.name, tb_s),
+        body = cls.raise_user_error('request_body', (cron.name, tb_s),
             raise_exception=False)
         values = {
             'name': name,
@@ -122,7 +136,7 @@
             'date_sent': datetime.datetime.now(),
             'references': [
                 ('create', {
-                    'reference': '%s,%s' % (self._name, cron.id),
+                    'reference': '%s,%s' % (cls.__name__, cron.id),
                 }),
             ],
             'state': 'waiting',
@@ -130,35 +144,36 @@
         }
         return values
 
-    def _callback(self, cron):
+    @classmethod
+    def _callback(cls, cron):
         pool = Pool()
         try:
             args = (cron.args or []) and safe_eval(cron.args)
-            model_obj = pool.get(cron.model)
+            Model = pool.get(cron.model)
             with Transaction().set_user(cron.user.id):
-                getattr(model_obj, cron.function)(*args)
+                getattr(Model, cron.function)(*args)
         except Exception:
             Transaction().cursor.rollback()
 
-            request_obj = pool.get('res.request')
+            Request = pool.get('res.request')
             req_user = cron.request_user
             language = (req_user.language.code if req_user.language
                     else CONFIG['language'])
             with contextlib.nested(Transaction().set_user(cron.user.id),
                     Transaction().set_context(language=language)):
-                values = self._get_request_values(cron)
-                request_obj.create(values)
+                values = cls._get_request_values(cron)
+                Request.create(values)
             Transaction().cursor.commit()
 
-    def run(self, db_name):
+    @classmethod
+    def run(cls, db_name):
         now = datetime.datetime.now()
         with Transaction().start(db_name, 0) as transaction:
-            transaction.cursor.lock(self._table)
-            cron_ids = self.search([
-                ('number_calls', '!=', 0),
-                ('next_call', '<=', datetime.datetime.now()),
-            ])
-            crons = self.browse(cron_ids)
+            transaction.cursor.lock(cls._table)
+            crons = cls.search([
+                    ('number_calls', '!=', 0),
+                    ('next_call', '<=', datetime.datetime.now()),
+                    ])
 
             for cron in crons:
                 try:
@@ -167,19 +182,17 @@
                     first = True
                     while next_call < now and number_calls != 0:
                         if first or cron.repeat_missed:
-                            self._callback(cron)
-                        next_call += self.get_delta(cron)
+                            cls._callback(cron)
+                        next_call += cls.get_delta(cron)
                         if number_calls > 0:
                             number_calls -= 1
                         first = False
 
-                    values = {
-                        'next_call': next_call,
-                        'number_calls': number_calls,
-                    }
+                    cron.next_call = next_call
+                    cron.number_calls = number_calls
                     if not number_calls:
-                        values['active'] = False
-                    self.write(cron.id, values)
+                        cron.active = False
+                    cron.save()
                     transaction.cursor.commit()
                 except Exception:
                     transaction.cursor.rollback()
@@ -188,5 +201,3 @@
                     tb_s = tb_s.decode('utf-8', 'ignore')
                     logger = logging.getLogger('cron')
                     logger.error('Exception:\n%s' % tb_s)
-
-Cron()
